config/routes.rb
Rails.application.routes.draw do
  devise_for :usuarios
  root to: 'painel#index'

  resources :alunos
  resources :livros
  resources :materias
  resources :cursos
  resources :semestres
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/aluno.rb
class Aluno < ApplicationRecord
  paginates_per 5
  belongs_to :curso

  def self.search(search)
    where('nome like ?', "%#{search}%").order(:nome)
  end
end

app/controllers/alunos_controller.rb
class AlunosController < ApplicationController
  before_action :set_aluno, only: %i[show edit update destroy]
  before_action :authenticate_usuario!
  # GET /alunos
  # GET /alunos.json
  def index
    @alunos = if params[:search].present?
                Aluno.search(params[:search]).page params[:page]
              else
                Aluno.order(:nome).page params[:page]
    end
  end

  # GET /alunos/1
  # GET /alunos/1.json
  def show; end

  # GET /alunos/new
  def new
    @aluno = Aluno.new
  end

  # GET /alunos/1/edit
  def edit; end

  # POST /alunos
  # POST /alunos.json
  def create
    @aluno = Aluno.new(aluno_params)

    respond_to do |format|
      if @aluno.save
        format.html { redirect_to @aluno, notice: t('.new', default: t('helpers.messages.new')) }
        format.json { render :show, status: :created, location: @aluno }
      else
        format.html { render :new }
        format.json { render json: @aluno.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /alunos/1
  # PATCH/PUT /alunos/1.json
  def update
    respond_to do |format|
      if @aluno.update(aluno_params)
        format.html { redirect_to @aluno, notice: t('.update', default: t('helpers.messages.update')) }
        format.json { render :show, status: :ok, location: @aluno }
      else
        format.html { render :edit }
        format.json { render json: @aluno.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /alunos/1
  # DELETE /alunos/1.json
  def destroy
    @aluno.destroy
    respond_to do |format|
      format.html { redirect_to alunos_url, notice: t('.destroy', default: t('helpers.messages.destroy')) }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_aluno
    @aluno = Aluno.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def aluno_params
    params.require(:aluno).permit(:nome, :ra, :email, :curso_id, :search)
  end
end

app/helpers/alunos_helper.rb
module AlunosHelper
end

app/views/alunos/_form-search.html.erb
<div class="row justify-content-first">
  <div class="col-12 mb-3">
    <%= form_tag alunos_path, method: :get, class: "navbar-form form-inline search-form" do %>
    <div class="form-group">
      <%= label_tag :search, "Pesquisar", class: "mr-2" %>
      <%= text_field_tag( :search, params[:search], placeholder: "Ex: João", class: "form-control mr-2 float-left" ) %>
    </div>
    <div class="form-group">
      <%= submit_tag "Pesquisar", class: "btn btn-primary float-right" %>
    </div>

  <% end %>
</div>
</div>

app/views/alunos/_form.html.erb
<%= form_with(model: aluno, local: true) do |form| %>
<% if aluno.errors.any? %>
  <div class="alert alert-danger">
    <h2><%= pluralize(aluno.errors.count, "error") %>
      prohibited this aluno from being saved:</h2>

    <ul>
      <% aluno.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
    </ul>
  </div>
<% end %>

<div class="form-group">
  <%= form.label :nome %>
  <%= form.text_field :nome, class: "form-control" %>
</div>

<div class="form-group">
  <%= form.label :ra %>
  <%= form.text_field :ra, class: "form-control" %>
</div>

<div class="form-group">
  <%= form.label :email %>
  <%= form.text_field :email, class: "form-control" %>
</div>

<div class="form-group">
  <%= form.label :curso_id %>
  <%= form.collection_select :curso_id, Curso.order(:descricao), :id, :descricao, {:prompt=> "Selecione o curso"}, {class: "form-control"} %>
</div>

<div class="form-group">
  <%= form.submit nil, class: "btn btn-primary" %>
</div>
<% end %>

app/views/alunos/edit.html.erb
<%= title "Editar Aluno" %>
<div class="container">
  <div class="row">
    <div class="col-lg-12">
      <% model_class = Aluno %>
        <h1 class="mt-2 pb-2">
          <%= t('.edit', :default=> t('helpers.title.edit', :model=> model_class.model_name.human.titleize))%>
        </h1>

        <%= render 'form', aluno: @aluno %>

        <%= link_to t('.show',:default=> t('helpers.submit.show')), @aluno, class: "btn btn-info btn-sm" %>
        |
        <%= link_to t('.back',:default=> t('helpers.submit.back')), alunos_path, class: "btn btn-danger btn-sm" %>
      </div>
    </div>
  </div>

app/views/alunos/index.html.erb
<%= title "Alunos" %>
<div class="container">
  <div class="row">
    <div class="col-lg-12">
      <% model_class = Aluno %>
        <h1 class="mt-2 pb-2"><%= t('.list', :default=> t('helpers.title.list', :model=> model_class.model_name.human.titleize.pluralize)) %></h1>

        <%= render partial: 'form-search' %>
        <div class="table-responsive">
          <table class="table table-striped table-hover">
            <thead class="thead-dark">
              <tr>
                <th scope="col">#</th>
                <th scope="col"><%= model_class.human_attribute_name(:nome) %></th>
                <th scope="col"><%= model_class.human_attribute_name(:ra) %></th>
                <th scope="col"><%= model_class.human_attribute_name(:email) %></th>
                <th scope="col"><%= model_class.human_attribute_name(:curso_id) %></th>
                <th scope="col" colspan="3" class="text-center"><%= t('.options', :default=> t('helpers.options')) %></th>
              </tr>
            </thead>
            <tbody>
              <% @alunos.each do |aluno| %>
                <tr>
                  <th scope="row"><%= aluno.id %></th>
                  <td><%= aluno.nome %></td>
                  <td><%= aluno.ra %></td>
                  <td><%= aluno.email %></td>
                  <td><%= aluno.curso.descricao %></td>
                  <td><%= link_to t('.show', :default=> t('helpers.submit.show')), aluno, class: "btn btn-outline-info btn-sm" %></td>
                  <td><%= link_to t('.edit', :default=> t('helpers.submit.edit')), edit_aluno_path(aluno), class: "btn btn-outline-success btn-sm" %></td>
                  <td><%= link_to t('.delete', :default=> t('helpers.submit.delete')), aluno, class: "btn btn-outline-danger btn-sm", method: :delete, data: { confirm: t('.delete', :default=> t('helpers.messages.delete')) } %></td>
                </tr>
              <% end %>
            </tbody>
          </table>
        </div>
        <br>
        <%= link_to t('.new', :default=> t('helpers.submit.new')), new_aluno_path, class: "btn btn-primary" %>
        <div class="row justify-content-center mb-3">
          <div class="col-6">
            <div class="row justify-content-end">
              <%= page_entries_info @alunos, entry_name: "#{model_class.model_name.human.titleize}(s)" %>
            </div>
          </div>
          <div class="col-6">
            <div class="row justify-content-end">
              <%= paginate @alunos, theme: 'twitter-bootstrap-4', pagination_class: "pagination-sm" %>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

app/views/alunos/new.html.erb
<%= title "Cadastrar Aluno" %>
<div class="container">
  <div class="row">
    <div class="col-12">
      <% model_class = Aluno %>
        <h1 class="mt-2 pb-2"><%= t('.new', :default=> t('helpers.title.new', :model=> model_class.model_name.human.titleize)) %></h1>

        <%= render 'form', aluno: @aluno %>

        <%= link_to t('.back', :default=> t('helpers.submit.back')), alunos_path, class: "btn btn-danger btn-sm mb-3" %>
        <br>
      </div>
    </div>
  </div>

app/views/alunos/show.html.erb
<%= title "Visualizar Aluno" %>
<% model_class = Aluno %>
  <div class="container">
    <div class="row">
      <div class="col-4">
        <div class="card mt-2 bg-light text-black">
          <div class="card-header bg-primary text-white">
            <h4><%= model_class.model_name.human.titleize %></h4>
          </div>
          <div class="card-body">
            <h4 class="card-title"><%= @aluno.nome %></h4>
            <p class="card-text">
              <strong><%= model_class.human_attribute_name(:ra) %>:</strong>
              <%= @aluno.ra %>
              <br>
              <strong><%= model_class.human_attribute_name(:email) %>:</strong>
              <%= @aluno.email %>
              <br>
              <strong><%= model_class.human_attribute_name(:curso_id) %>:</strong>
              <%= @aluno.curso.descricao %>
              <br>
              <strong><%= model_class.human_attribute_name(:created_at) %>:</strong>
              <%= @aluno.created_at.strftime("%d/%m/%Y") %>
            </p>
          </div>
          <div class="card-footer">
            <%= link_to t('.edit', :default=> t('helpers.submit.edit')), edit_aluno_path(@aluno), class: "btn btn-success btn-sm" %>
            |
            <%= link_to t('.back', :default=> t('helpers.submit.back')), alunos_path, class: "btn btn-danger btn-sm" %>
          </div>
        </div>
      </div>
    </div>
  </div>